/*
    QGL MaterialsEditor
    Ivan Pelipenko peri4ko@yandex.ru

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef MATERIALS_EDITOR_H
#define MATERIALS_EDITOR_H

#include "gltypes.h"

#include <QFileDialog>

namespace Ui {
class MaterialsEditor;
}

class MaterialsEditor: public QWidget {
	Q_OBJECT

public:
	explicit MaterialsEditor(QWidget * parent = 0);

	void assignQGLView(QGLView * v);

protected:
	bool event(QEvent * e);
	void changeEvent(QEvent * e);
	Material * currentMaterial();
	void selectMaterial(Material * m);
	int indexByMaterial(Material * m);

	Ui::MaterialsEditor * ui;
	QGLView * view;
	Material * mat;

private slots:
	void selectionChanged();
	void materialsChanged();
	void materialThumbnailCreated(Material * m);

	void on_comboMaterial_currentIndexChanged(int index);
	void on_buttonRename_clicked();
	void on_buttonAdd_clicked();
	void on_buttonClone_clicked();
	void on_buttonDelete_clicked();
	void on_buttonAssign_clicked();
	void on_buttonUnset_clicked();

signals:
	void changed();
};

#endif // MATERIALS_EDITOR_H
